/**
 * Schreibt eine Text auf die Leinwand.
 * 
 * @author Bernd Gramlich
 * @version 2008.05.14
 */
public class Beschriftung
{
    /*
     * Position des Textes
     */
    private int positionX;
    private int positionY;
    
    /*
     * Der Text.
     */
    private String inhalt;
    
    /*
     * Farbe, Schriftgre und Sichtbarkeit.
     */
    private String farbe;
    private int schriftgroesse;
    private boolean sichtbar;

    /**
     * Konstruktor der Klasse Beschriftung.
     * Erzeugt eine neue Beschriftung mit Standardtext in Standardgre und Standardfarbe.
     */
    public Beschriftung ()
    { 
        positionX      = 100;
        positionY      = 100;
        
        inhalt         = "Informatik macht Spa.";

        farbe          = "grau";
        schriftgroesse = 12;
        sichtbar       = false;
    }
    
	/**
	 * Mache diesen Text sichtbar.
	 */
	public void macheSichtbar ()
	{
		sichtbar = true;
		schreibe ();
	}

	/**
	 * Mache diesen Text unsichtbar.
	 */
	public void macheUnsichtbar ()
	{
		radiere ();
		sichtbar = false;
	}
	

	/**
	 * ndere die Farbe dieses Textes in 'neueFarbe'. Gltige Angaben
	 * sind "rot", "gelb", "blau", "grn", "lila", "schwarz", "wei", "grau"
	 * "orange", "pink" und "trkis".
	 */
	public void setzeFarbe (String neueFarbe)
	{
		farbe = neueFarbe;
		schreibe ();
	}
	
    /**
	 * ndere die Position dieses Textes.
	 */
	public void setzePosition (int neuePositionX, int neuePositionY)
	{
		positionX = neuePositionX;
		positionY = neuePositionY;
		schreibe ();
	}

	/**
	 * ndere die Schriftgre dieses Textes.
	 */
	public void setzeSchriftgroesse (int neueSchriftgroesse)
	{
		schriftgroesse = neueSchriftgroesse;
		schreibe ();
	}

    /**
	 * ndere den Inhalt dieses Textes.
	 */
	public void setzeInhalt (String neuerInhalt)
	{
		inhalt = neuerInhalt;
		schreibe ();
	}
	
	/**
	 * Verschiebe diesen Text waagrecht um 'entfernung' Bildschirmpunkte.
	 */
	public void verschiebeWaagrecht (int entfernung)
	{
		radiere ();
		positionX += entfernung;
		schreibe ();
	}

	/**
	 * Verschiebe diesen Text senkrecht um 'entfernung' Bildschirmpunkte.
	 */
	public void verschiebeSenkrecht (int entfernung)
	{
		radiere ();
		positionY += entfernung;
		schreibe ();
	}

	/**
	 * Gleite diesen Text waagrecht um 'entfernung' Bildschirmpunkte.
	 */
	public void gleiteWaagrecht (int entfernung)
	{
		int delta;

		if (entfernung < 0)
		{
			delta = -1;
			entfernung = -entfernung;
		}
		else
		{
			delta = 1;
		}

		for (int i = 0; i < entfernung; i++)
		{
			positionX += delta;
			schreibe ();
		}
	}

	/**
	 * Gleite diesen Text senkrecht um 'entfernung' Bildschirmpunkte.
	 */
	public void gleiteSenkrecht (int entfernung)
	{
		int delta;

		if (entfernung < 0)
		{
			delta = -1;
			entfernung = -entfernung;
		}
		else
		{
			delta = 1;
		}

		for (int i = 0; i < entfernung; i++)
		{
			positionY += delta;
			schreibe ();
		}
	}

	/**
	 * Schreibe diesen Text auf die Leinwand.
	 */
	private void schreibe ()
	{
		if (sichtbar)
		{
			Leinwand leinwand = Leinwand.gibLeinwand ();
			leinwand.schreibe (this, farbe, inhalt, positionX, positionY, schriftgroesse);
			leinwand.warte (10);
		}
	}

	/**
	 * Lsche diesen Text von der Leinwand.
	 */
	private void radiere ()
	{
		if (sichtbar)
		{
			Leinwand leinwand = Leinwand.gibLeinwand ();
			leinwand.radiere (this);
		}
	}
	
	/**
	 * Nenne den Text dieser Beschriftung.
	 */
	public String gibText ()
	{
	    return inhalt;
	}
}