/**
 * Eine Reihe von Streichhlzer.
 * 
 * @author Bernd Gramlich 
 * @version 2013-03-01
 */
public class Reihe
{
    // Attribute
    // Maximalzahl und augenblicklich sichtbare Zahl von
    // Streichhlzern in der Reihe.
    private int maximalzahl;
    private int anzahl;
    
    // Die Streichhlzer dieser Reihe als Feld holz.
    private Streichholz[] holz;

    /**
     * Konstruktor.
     * Platziere die Reihe ab den Bildschirmkoordinaten (x|y)
     * und erlaube insgesamt "max" Hlzer in der Reihe.
     */
    public Reihe (int x, int y, int max)
    {
        // Die Reihe soll hchstens 7 Hlzer enthalten.
        maximalzahl = max;
        
        // Am Anfang sollen alle Hlzer sichtbar sein.
        anzahl = maximalzahl;
        
        // Erzeuge alle Streichhlzer und platziere sie
        // nebeneinander.
        holz = new Streichholz[maximalzahl];
        
        for (int i = 0; i < maximalzahl ; i++)
        {
            holz[i] = new Streichholz (10, x + 20*i, y);
        }
        
        // Zeige die gesamte Streichholzreihe an.
        zeige ();
    }
    
    /**
     * Zeige die noch vorhandenen Streichhlzer an und
     * mache die anderen unsichtbar.
     */
    private void zeige ()
    {
       /*
        * Zeige die ersten anzahl Streichhlzer an.
        */
       for (int i = 0; i < anzahl; i++)
       {
           holz[i].macheSichtbar ();
       }
       
       /*
        * Mache alle brigen Streichhlzer unsichtbar.
        */
       for (int j = anzahl; j < maximalzahl; j++)
       {
           holz[j].macheUnsichtbar ();
       }
    }
    
    /**
     * Nimm so viele Hlzchen weg wie angegeben.
     * 
     * true bei Erfolg
     * false bei Misserfolg
     */
    public boolean nimmWeg (int wegzahl)
    {
        /*
         * Wenn wir hchstens so viele Hlzchen wegnehmen
         * wollen, wie da sind ...
         */
        if (wegzahl <= anzahl && wegzahl >= 1)
        {
            /*
             * ..., dann nehmen wir sie weg und melden true
             * (Erfolg) zurck ...
             */
            anzahl = anzahl - wegzahl;
            
            zeige ();
            
            return true;
        }
        else
        {
            /*
             * ... sonst melden wir false (Misserfolg) zurck.
             */
            return false;
        }
    }
    
    /**
     * Nenne die Anzahl der Hlzchen in der Reihe.
     */
    public int gibAnzahl ()
    {
        return anzahl;
    }
    
    /**
     * Setze die Anzahl der Hlzchen in der Reihe auf den
     * angegebenen Wert.
     */
    public void setzeAnzahl (int neueAnzahl)
    {
        if (neueAnzahl <= maximalzahl)
        {
            anzahl = neueAnzahl;
            
            zeige ();
        }
    }
}
