/**
 * Ein Streichholz.
 * 
 * @author Bernd Gramlich 
 * @version 2012-09-20
 */
public class Streichholz
{
    // Referenzattribute
    private Rechteck stab;
    private Ellipse kopf;

    /**
     * Konstruktor.
     * Das Streichholz soll die Breite breite haben und an der
     * Stelle (x|y) positioniert werden.
     * Das Streichholz soll zehnmal so hoch wie breit sein.
     */
    public Streichholz (int breite, int x, int y)
    {
        stab = new Rechteck ();
        kopf = new Ellipse ();
        
        stab.setzeBreite (breite);
        stab.setzeHoehe (10*breite);
        stab.setzePosition (x, y + breite);
        stab.setzeFarbe ("gelb");
        
        kopf.setzeBreite (2*breite);
        kopf.setzeHoehe (3*breite);
        kopf.setzePosition (x-breite/2, y);
        kopf.setzeFarbe ("rot");
    }

    /**
     * Mache das Streichholz sichtbar. 
     */
    public void macheSichtbar ()
    {
        stab.macheSichtbar ();
        kopf.macheSichtbar ();
    }

    /**
     * Mache das Streichholz unsichtbar. 
     */
    public void macheUnsichtbar ()
    {
        stab.macheUnsichtbar ();
        kopf.macheUnsichtbar ();
    }
}