/**
 * Stelle eine Zahl als Wrfel auf der Leinwand dar.
 * 
 * @author Bernd Gramlich 
 * @version 2013-03-01
 */
public class Wuerfeldarstellung implements ZahlBeobachter
{
    /*
     * Der Spielwrfel auf der Leinwand.
     */
    private Wuerfel spielwuerfel;
    
    /*
     * Der Zahlerzeuger, von dem wir unsere Zahl erhalten.
     */
    private ZahlErzeuger erzeuger;
    
    /**
     * Konstruktor.
     * Erzeuge den Spielwrfel fr den Zahlerzeuger e.
     */
    public Wuerfeldarstellung (ZahlErzeuger e)
    {
       erzeuger = e;
       
       spielwuerfel = new Wuerfel (10, 10, "rot", "schwarz");
       spielwuerfel.macheUnsichtbar ();
    }

    /**
     * Aktualisiere die Zahl.
     */
    public void aktualisiereZahl ()
    {
        int neueZahl = erzeuger.gibZahl ();
        System.out.println (neueZahl);
        
        if (1 <= neueZahl && neueZahl <= 6)
        {
            spielwuerfel.macheSichtbar ();
            spielwuerfel.setzeAugenzahl (neueZahl);
        }
        else
        {
            spielwuerfel.macheUnsichtbar ();
        }
    }
}
