/**
 * Ein Zahlerzeuger.
 * 
 * @author Bernd Gramlich 
 * @version 2013-03-01
 */
public interface ZahlErzeuger
{
    /**
     * Nenne die aktuelle Zahl.
     * 
     * @return Die aktuelle Zahl.
     */
    int gibZahl ();
    
    /**
     * Speichere einen Zahlbeobachter.
     * 
     * @param b Der Zahlbeobachter.
     */
    void speichereAlsBeobachter (ZahlBeobachter b);

    /**
     * Loesche einen Zahlbeobachter.
     * 
     * @param b Der Zahlbeobachter.
     */
    void loescheAlsBeobachter (ZahlBeobachter b);
}
